collectible_data = { }

collectible_data['energy'] = love.graphics.newImage( 'collectible/energy/energy.png' )
collectible_data['energy_light'] = love.graphics.newImage( 'collectible/energy/energy_light.png' )
collectible_data['energy_sphere'] = love.graphics.newImage( 'collectible/energy/energy_sphere.png' )

collectible_data['shields'] = love.graphics.newImage( 'collectible/shields/shields.png' )
collectible_data['shields_light'] = love.graphics.newImage( 'collectible/shields/shields_light.png' )
collectible_data['shields_lightning'] = love.graphics.newImage( 'collectible/shields/shields_lightning.png' )

function collectible_create( x, y, type )
	collectible[#collectible + 1] = { x = x, y = y, type = type, angle = -0.25 }
end

function collectible_check( n )
	result = 0
	
	for i = 1, #ship do
		if collectible[n].x > ship[i].x and collectible[n].x < ship[i].x + ship[i].width and collectible[n].y > ship[i].y and collectible[n].y < ship[i].y + ship[i].height and not ship[i].death then
			result = i
			ship[i].ai.collectible = 0
			
			local x = ship[game.camera].x - collectible[n].x
			local y = ship[game.camera].y - collectible[n].y
			local distance = math.sqrt( x * x + y * y )
			if distance < 2048 then
				sound[#sound + 1] = love.audio.newSource( 'sound/collect.ogg', 'static' )
				sound[#sound]:setVolume( ( 2048 - distance ) / 4096 )
				love.audio.play( sound[#sound] )
			end
			
			break
		end
	end
	
	return result
end

function collectible_update( n, k, dt )
	if collectible[n].type == 'energy' then
		collectible[n].angle = collectible[n].angle + 1 * dt
	else
		collectible[n].angle = math.random( 0, 100 ) / 100 * 0.3 + math.random( 0, 1 )
	end
	
	result = collectible_check( n )
	if result ~= 0 then
		if collectible[n].type == 'energy' then
			ship[result].energy = ship[result].energy + 50
			if ship[result].energy > 200 then
				ship[result].energy = 200
			end
		elseif collectible[n].type == 'shields' then
			ship[result].shields = ship[result].shields + 50
			if ship[result].shields > 200 then
				ship[result].shields = 200
			end
		end
		
		table.remove( collectible, n )
		n = n - 1
		k = k - 1
	end
	
	return n, k
end

function collectible_draw( n )
	love.graphics.setColor( 255, 255, 255, 255 )
	love.graphics.draw( collectible_data[collectible[n].type], collectible[n].x - 16 - game.x, collectible[n].y - 16 - game.y )
	
	if collectible[n].type == 'energy' then
		love.graphics.draw( collectible_data['energy_light'], collectible[n].x - 64 - game.x, collectible[n].y - 64 - game.y )
		love.graphics.draw( collectible_data['energy_sphere'], collectible[n].x - game.x, collectible[n].y - game.y, collectible[n].angle * math.pi, 1, 1, 16, 16 )
		love.graphics.draw( collectible_data['energy_sphere'], collectible[n].x - game.x, collectible[n].y - game.y, collectible[n].angle * -1 * math.pi, 1, 1, 16, 16 )
	elseif collectible[n].type == 'shields' then
		love.graphics.draw( collectible_data['shields_light'], collectible[n].x - 64 - game.x, collectible[n].y - 64 - game.y )
		love.graphics.draw( collectible_data['shields_lightning'], collectible[n].x - game.x, collectible[n].y - game.y, collectible[n].angle * math.pi, 1, 1, 16, 16 )
	end
end