level = { timer = 30, team = { number = 2, name = { 'CED', 'PTMC' }, colour = { { red = 125, green = 125, blue = 255 }, { red = 255, green = 125, blue = 125 } } } }

level_data = { }

spawn_point = { { { x = 256, y = 128 }, { x = 512, y = 128 }, { x = 3456, y = 384 }, { x = 3256, y = 384 } }, { { x = 384, y = 3456 }, { x = 584, y = 3456 }, { x = 3200, y = 3456 }, { x = 3400, y = 3456 } } }

function level.set( )
	local ships = { { x = 3456, y = 128 }, { x = 128, y = 3456 }, { x = 3456, y = 3456 }, { x = 256, y = 128 }, { x = 3456, y = 256 }, { x = 128, y = 3400 }, { x = 3456, y = 300 }, { x = 256, y = 128 }, { x = 512, y = 128 }, { x = 3456, y = 384 }, { x = 3256, y = 384 }, { x = 384, y = 3456 }, { x = 584, y = 3456 }, { x = 3200, y = 3456 }, { x = 3400, y = 3456 }, { x = 256, y = 128 }, { x = 512, y = 128 }, { x = 3456, y = 384 }, { x = 3256, y = 384 }, { x = 384, y = 3456 }, { x = 584, y = 3456 }, { x = 3200, y = 3456 }, { x = 3400, y = 3456 } }
	
	ship_create( 1280, 256, menu.state[2], menu.state[5], menu.nickname, menu.state[4] )
	if menu.state[3] > 0 then
		local i = 1
		while i <= menu.state[3] do
			local team = ship[game.camera].team
			
			if i >= math.ceil( ( menu.state[3] + 1 ) / 2 ) then
				team = 3 - team
			end
			
			ship_create( ships[i].x, ships[i].y, math.random( 1, 5 ), true, nickname[math.random( 1, #nickname )], team )
			
			i = i + 1
		end
	end
	
	level_data.floor = love.graphics.newImage( 'level/kabba/resource/texture/floor.png' )
	level_data.wall = love.graphics.newImage( 'level/kabba/resource/texture/wall.png' )
	
	--big boundaries
	--up
	wall_create( -512, -512, 4608, 512 )
	--down
	wall_create( -512, 3584, 4608, 512 )
	--left
	wall_create( -512, 0, 512, 3584 )
	--right
	wall_create( 3584, 0, 512, 3584 )
	--smaller walls
	--horizontal begins, vertical ends
	--upper left
	wall_create( 512, 512, 1024, 512 )
	wall_create( 512, 512, 512, 1024 )
	--lower left
	wall_create( 512, 2560, 1024, 512 )
	wall_create( 512, 2048, 512, 1024 )
	--upper right
	wall_create( 2048, 512, 1024, 512 )
	wall_create( 2560, 512, 512, 1024 )
	--lower right
	wall_create( 2048, 2560, 1024, 512 )
	wall_create( 2560, 2048, 512, 1024 )
	--central wall
	wall_create( 1536, 1536, 512, 512 )
end

collectible_spawn = { { x = 1280, y = 1280 }, { x = 2304, y = 1280 }, { x = 1280, y = 2304 }, { x = 2304, y = 2304 } }

function level.update( dt )
	if not game.pause then
		level.timer = level.timer + 1 * dt
	end
	
	if level.timer > 30 then
		collectible_spawn = { { x = 1280, y = 1280 }, { x = 2304, y = 1280 }, { x = 1280, y = 2304 }, { x = 2304, y = 2304 } }
		
		level.timer = 0
		local free_points = { }
		local k = 4
		local i = 1
		while i <= k do
			if #collectible > 0 then
				for j = 1, #collectible do
					if collectible_spawn[i].x == collectible[j].x and collectible_spawn[i].y == collectible[j].y and collectible[j].type == 'shields' then
						table.remove( collectible_spawn, i )
						i = i - 1
						k = k - 1
						break
					end
				end
			end
			i = i + 1
		end
		
		if #collectible_spawn > 0 then
			for i = 1, #collectible_spawn do
				collectible_create( collectible_spawn[i].x, collectible_spawn[i].y, 'shields' )
			end
		end
	end
end

function level.draw_front( )
	love.graphics.setColor( 255, 255, 255 )
	--second row
	love.graphics.draw( level_data.wall, 512 - game.x, 512 - game.y )
	love.graphics.draw( level_data.wall, 1024 - game.x, 512 - game.y )
	love.graphics.draw( level_data.wall, 2048 - game.x, 512 - game.y )
	love.graphics.draw( level_data.wall, 2560 - game.x, 512 - game.y )
	--third row
	love.graphics.draw( level_data.wall, 512 - game.x, 1024 - game.y )
	love.graphics.draw( level_data.wall, 2560 - game.x, 1024 - game.y )
	--fourth row
	love.graphics.draw( level_data.wall, 1536 - game.x, 1536 - game.y )
	--fifth row
	love.graphics.draw( level_data.wall, 512 - game.x, 2048 - game.y )
	love.graphics.draw( level_data.wall, 2560 - game.x, 2048 - game.y )
	--sixth row
	love.graphics.draw( level_data.wall, 512 - game.x, 2560 - game.y )
	love.graphics.draw( level_data.wall, 1024 - game.x, 2560 - game.y )
	love.graphics.draw( level_data.wall, 2048 - game.x, 2560 - game.y )
	love.graphics.draw( level_data.wall, 2560 - game.x, 2560 - game.y )
	
	for i = 1, 9 do
		if i == 1 or i == 9 then
			for j = 1, 9 do
				love.graphics.draw( level_data.wall, -1024 + j * 512 - game.x, -1024 + i * 512 - game.y )
			end
		else
			love.graphics.draw( level_data.wall, -512 - game.x, -1024 + i * 512 - game.y )
			love.graphics.draw( level_data.wall, 3584 - game.x, -1024 + i * 512 - game.y )
		end
	end
end

function level.draw_back( )
	love.graphics.setColor( 255, 255, 255 )
	--first row
	love.graphics.draw( level_data.floor, 0 - game.x, 0 - game.y )
	love.graphics.draw( level_data.floor, 512 - game.x, 0 - game.y )
	love.graphics.draw( level_data.floor, 1024 - game.x, 0 - game.y )
	love.graphics.draw( level_data.floor, 1536 - game.x, 0 - game.y )
	love.graphics.draw( level_data.floor, 2048 - game.x, 0 - game.y )
	love.graphics.draw( level_data.floor, 2560 - game.x, 0 - game.y )
	love.graphics.draw( level_data.floor, 3072 - game.x, 0 - game.y )
	--second row
	love.graphics.draw( level_data.floor, 0 - game.x, 512 - game.y )
	love.graphics.draw( level_data.floor, 1536 - game.x, 512 - game.y )
	love.graphics.draw( level_data.floor, 3072 - game.x, 512 - game.y )
	--third row
	love.graphics.draw( level_data.floor, 0 - game.x, 1024 - game.y )
	love.graphics.draw( level_data.floor, 1024 - game.x, 1024 - game.y )
	love.graphics.draw( level_data.floor, 1536 - game.x, 1024 - game.y )
	love.graphics.draw( level_data.floor, 2048 - game.x, 1024 - game.y )
	love.graphics.draw( level_data.floor, 3072 - game.x, 1024 - game.y )
	--fourth row
	love.graphics.draw( level_data.floor, 0 - game.x, 1536 - game.y )
	love.graphics.draw( level_data.floor, 512 - game.x, 1536 - game.y )
	love.graphics.draw( level_data.floor, 1024 - game.x, 1536 - game.y )
	love.graphics.draw( level_data.floor, 2048 - game.x, 1536 - game.y )
	love.graphics.draw( level_data.floor, 2560 - game.x, 1536 - game.y )
	love.graphics.draw( level_data.floor, 3072 - game.x, 1536 - game.y )
	--fifth row
	love.graphics.draw( level_data.floor, 0 - game.x, 2048 - game.y )
	love.graphics.draw( level_data.floor, 1024 - game.x, 2048 - game.y )
	love.graphics.draw( level_data.floor, 1536 - game.x, 2048 - game.y )
	love.graphics.draw( level_data.floor, 2048 - game.x, 2048 - game.y )
	love.graphics.draw( level_data.floor, 3072 - game.x, 2048 - game.y )
	--sixth row
	love.graphics.draw( level_data.floor, 0 - game.x, 2560 - game.y )
	love.graphics.draw( level_data.floor, 1536 - game.x, 2560 - game.y )
	love.graphics.draw( level_data.floor, 3072 - game.x, 2560 - game.y )
	--seventh row
	love.graphics.draw( level_data.floor, 0 - game.x, 3072 - game.y )
	love.graphics.draw( level_data.floor, 512 - game.x, 3072 - game.y )
	love.graphics.draw( level_data.floor, 1024 - game.x, 3072 - game.y )
	love.graphics.draw( level_data.floor, 1536 - game.x, 3072 - game.y )
	love.graphics.draw( level_data.floor, 2048 - game.x, 3072 - game.y )
	love.graphics.draw( level_data.floor, 2560 - game.x, 3072 - game.y )
	love.graphics.draw( level_data.floor, 3072 - game.x, 3072 - game.y )
end