function ray_trace( line_begin, line_end, quad_begin, quad_end )
	local value = { }
	
	local quad = { quad_begin, { x = quad_end.x, y = quad_begin.y }, quad_end, { x = quad_begin.x, y = quad_end.y } }
	
	local order = { { 1, 2 }, { 2, 3 }, { 4, 3 }, { 1, 4 } }
	
	for i = 1, 4 do
		--function start
		local line_fbegin, line_fend, line_sbegin, line_send = line_begin, line_end, quad[order[i][1]], quad[order[i][2]]
		local result = { status = false, x = 0, y = 0 }
		
		if line_sbegin.y == line_send.y then
			result.x = line_fbegin.x + ( ( line_sbegin.y - line_fbegin.y ) / ( line_fend.y - line_fbegin.y ) ) * ( line_fend.x - line_fbegin.x )
			result.y = line_sbegin.y
			if result.x > line_sbegin.x and result.x < line_send.x then
				result.status = true
			end
		elseif line_sbegin.x == line_send.x then
			result.y = line_fbegin.y + ( ( line_sbegin.x - line_fbegin.x ) / ( line_fend.x - line_fbegin.x ) ) * ( line_fend.y - line_fbegin.y )
			result.x = line_sbegin.x
			if result.y > line_sbegin.y and result.y < line_send.y then
				result.status = true
			end
		end
		--local collision = line_check( line_begin, line_end, quad[order[i][1]], quad[order[i][2]] )
		--function end
		if result.status then
			local x = result.x
			local y = result.y
			
			if math.floor( math.sqrt( ( ( x - line_begin.x ) ^ 2 ) + ( ( y - line_begin.y ) ^ 2 ) ) + math.sqrt( ( ( line_end.x - x ) ^ 2 ) + ( ( line_end.y - y ) ^ 2 ) ) ) == math.floor( math.sqrt( ( ( line_end.x - line_begin.x ) ^ 2 ) + ( ( line_end.y - line_begin.y ) ^ 2 ) ) ) then
				value[#value + 1] = { x = x, y = y }
			end
		end
	end
	
	return value
end