love.filesystem.load( 'library.lua' ) ( )

game = { current = -1, pause = false, alpha = 0, camera = 1, player = 1, x = 0, y = 0, dt = 0, score = { 0, 0 } }

menu = { current = 1, state = { 1, 1, 15, 1, false }, map = { }, ship = { 'pyro', 'phoenix', 'magnum', 'sharpshooter', 'thor' }, input = false, nickname = 'player' }

ship = { }

collectible = { }

message = { '', '', '', '', '' }

level = { timer = 30, team = { number = 2, name = { 'CED', 'PTMC' }, colour = { { red = 0, green = 0, blue = 255 }, { red = 255 } } } }

wall = { }

nickname = { 'Jim', 'David', 'Roland', 'Sara', 'Leo', 'Alex', 'Richard', 'Duke', 'Simon', 'Brad', 'George', 'Benjamin', 'Paul', 'Jack', 'Max', 'Raphael' }

love.audio.setVolume( 0.1 )

sound = { }

function wall_create( x, y, width, height )
	wall[#wall + 1] = { x = x, y = y, width = width, height = height }
end

function wall_check( n )
	for i = 1, #wall do
		if ship[n].x + ship[n].width > wall[i].x and ship[n].x < wall[i].x + wall[i].width and ship[n].y + ship[n].height > wall[i].y and ship[n].y < wall[i].y + wall[i].height then 
			if ship[n].x + ship[n].width > wall[i].x and ship[n].x + ship[n].width < wall[i].x + 32 then
				ship[n].x = wall[i].x - ship[n].width
				ship[n].nx = 0
			elseif ship[n].x < wall[i].x + wall[i].width and ship[n].x > wall[i].x + wall[i].width - 32 then
				ship[n].x = wall[i].x + wall[i].width
				ship[n].nx = 0
			end
			if ship[n].y + ship[n].height > wall[i].y and ship[n].y + ship[n].height < wall[i].y + 32 then
				ship[n].y = wall[i].y - ship[n].height
				ship[n].ny = 0
			elseif ship[n].y < wall[i].y + wall[i].height and ship[n].y > wall[i].y + wall[i].height - 32 then
				ship[n].y = wall[i].y + wall[i].height
				ship[n].ny = 0
			end
		end
	end
end

function stats_view( )
	for i = 1, 2 do
		love.graphics.setColor( level.team.colour[i].red, level.team.colour[i].green, level.team.colour[i].blue, 128 )
		love.graphics.rectangle( 'fill', -200 + i * 300, 100, 300, 400 )
		
		love.graphics.setColor( 255, 255, 255, 255 )
		love.graphics.print( level.team.name[i], -175 + i * 300, 125 )
		
		love.graphics.print( 'Nickname', -175 + i * 300, 140 )
		love.graphics.print( 'Frags', -50 + i * 300 , 140 )
		love.graphics.print( 'Ship', i * 300, 140 )
		
		local player = { }
		for j = 1, #ship do
			if ship[j].team == i then
				player[#player + 1] = j
			end
		end
		
		for j = 1, #player - 1 do
			for n = 1, 8 do
				if ship[player[j]].stats.frags < ship[player[j + 1]].stats.frags then
					local buffer = player[j]
					player[j] = player[j + 1]
					player[j + 1] = buffer
				end
			end
		end
		
		for j = 1, #player do
			love.graphics.print( ship[player[j]].stats.name, -175 + i * 300, 145 + j * 15 )
			love.graphics.print( ship[player[j]].stats.frags, -50 + i * 300 , 145 + j * 15 )
			love.graphics.print( menu.ship[ship[player[j]].type], i * 300, 145 + j * 15 )
		end
	end
end

function menu.update_maps( )
	local fs = love.filesystem
	menu.map = fs.enumerate( 'level' )
end

function menu.set( )
	menu.current = 1
	game.alpha = 0
	menu.update_maps( )
end

menu.update_maps( )

function menu.update( dt )
	
end

function menu.draw( )
	love.graphics.setColor( 255, 255, 255, 255 )
	love.graphics.print( 'Flyer Deathmatch alpha 1.20', 30, 270 )
	
	love.graphics.print( 'Start game', 30, 300 )
	love.graphics.print( 'Map: ' .. menu.map[menu.state[1]], 30, 315 )
	love.graphics.print( 'Ship: ' .. menu.ship[menu.state[2]], 30, 330 )
	love.graphics.print( 'Name: ' .. menu.nickname, 30, 345 )
	love.graphics.print( 'AI ships: ' .. menu.state[3], 30, 360 )
	love.graphics.print( 'Team: ' .. menu.state[4], 30, 375 )
	love.graphics.print( 'First player\'s AI: ' .. tostring( menu.state[5] ), 30, 390 )
	love.graphics.print( 'Exit', 30, 405 )
	
	love.graphics.print( '>', 20, 285 + menu.current * 15 )
end

function menu.keypressed( key )
	if menu.input then
		if key == 'return' then
			menu.input = false
		else
			menu.nickname = menu.nickname .. key
		end
	else
		if key == 'up' and menu.current > 1 then
			menu.current = menu.current - 1
		end
		if key == 'down' and menu.current < 8 then
			menu.current = menu.current + 1
		end
		
		if key == 'left' then
			if menu.current == 2 and menu.state[1] > 1 then
				menu.state[1] = menu.state[1] - 1
			elseif menu.current == 3 and menu.state[2] > 1 then
				menu.state[2] = menu.state[2] - 1
			elseif menu.current == 5 and menu.state[3] > 0 then
				menu.state[3] = menu.state[3] - 1
			elseif menu.current == 6 and menu.state[4] > 1 then
				menu.state[4] = menu.state[4] - 1
			elseif menu.current == 7 then
				menu.state[5] = false
			end
		end
		if key == 'right' then
			if menu.current == 2 and menu.state[1] < #menu.map then
				menu.state[1] = menu.state[1] + 1
			elseif menu.current == 3 and menu.state[2] < #menu.ship then
				menu.state[2] = menu.state[2] + 1
			elseif menu.current == 5 and menu.state[3] < 15 then
				menu.state[3] = menu.state[3] + 1
			elseif menu.current == 6 and menu.state[4] < 2 then
				menu.state[4] = menu.state[4] + 1
			elseif menu.current == 7 then
				menu.state[5] = true
			end
		end
		
		if key == 'return' then
			if menu.current == 1 then
				game.current = 0
				if game.set then
					game.set( )
				end
			elseif menu.current == 4 then
				menu.nickname = ''
				menu.input = true
			elseif menu.current == 7 then
				love.event.quit( )
			end
		end
	end
end

function game.set( )
	love.filesystem.load( 'ship/ship.lua' ) ( )
	love.filesystem.load( 'collectible/object.lua' ) ( )
	love.filesystem.load( 'level/' .. menu.map[menu.state[1]] .. '/level.lua' ) ( )
	level.set( )
end

function game.update( dt )
	level.update( dt )
	
	if not game.pause then
		for i = 1, #ship do
			ship_update( i, dt )
		end
		local k = #collectible
		if k > 0 then
			local i = 1
			while true do
				if i <= k and i > 0 then
					i, k = collectible_update( i, k, dt )
					i = i + 1
				else
					break
				end
			end
		end
		
		game.x = ship[game.camera].x - 400 + ship[game.camera].width / 2
		game.y = ship[game.camera].y - 300 + ship[game.camera].height / 2
	end
	
	if #sound > 100 then
		table.remove( sound, 1 )
	end
end

function game.draw( )
	level.draw_back( )
	for i = 1, #ship do
		ship_draw( i )
	end
	
	if #collectible > 0 then
		for i = 1, #collectible do
			collectible_draw( i )
		end
	end
	
	level.draw_front( )
	
	if love.keyboard.isDown( 'tab' ) then
		stats_view( )
	end
	
	for i = 1, 2 do
		love.graphics.setColor( level.team.colour[i].red, level.team.colour[i].green, level.team.colour[i].blue )
		love.graphics.print( level.team.name[i] .. ' ' .. game.score[i] ,32, 32 + i * 15 )
	end
	
	love.graphics.setColor( 255, 255, 255, 255 )
	for i = 1, 5 do
		love.graphics.print( message[#message + 1 - i] , 600, 60 - 10 * i )
	end
	
	love.graphics.print( 'Missles: ' .. ship[game.camera].weapon.status[2][1], 650, 560 )
	love.graphics.print( 'Shields: ' .. ship[game.camera].shields, 650, 570 )
	love.graphics.print( 'Energy: ' .. ship[game.camera].energy, 650, 580 )
end

function game.keypressed( key )
	if key == 'escape' then
		game.pause = not game.pause
	end
end

function love.update( dt )
	if game.current == -1 then
		menu.update( dt )
	elseif game.current == 0 then
		game.update( dt )
	end
	
	game.dt = dt
end

function love.draw( )
	if game.current == -1 then
		menu.draw( )
	elseif game.current == 0 then
		game.draw( )
	end
end

function love.keypressed( key )
	if game.current == -1 then
		menu.keypressed( key )
	elseif game.current == 0 then
		game.keypressed( key )
	end
end