function ai_keys( n )
	keys = { false, false, false, false }
	
	local old_direction = ship[n].ai.direction
	
	for i = 1, #ship do
		if i ~= n then
			if ship[i].x > ship[n].x - 400 and ship[i].x < ship[n].x + 400 and ship[i].y > ship[n].y - 300 and ship[i].y < ship[n].y + 300 then
				local distance = math.sqrt( ( ship[i].x - ship[n].x ) ^ 2 + ( ship[i].y - ship[n].y ) ^ 2 )
				local multiplier = 1.5
				local enemy = i
				
				if ship[i].team == ship[n].team then
					multiplier = 1
					enemy = 0
				end
				
				local opposite = { 2, 1, 4, 3 }
				
				if distance < 128 * multiplier or ship[n].shields <= 50 then
					if enemy == 0 then
						ship[n].ai.direction = ship[i].ai.direction
					else
						if ship[n].x < ship[i].x then
							ship[n].ai.direction = 4
						else
							ship[n].ai.direction = 3
						end
						if ship[n].y < ship[i].y then
							ship[n].ai.direction = 2
						else
							ship[n].ai.direction = 1
						end
					end
				end
				
				if distance > 128 * multiplier then
					--ship[n].ai.direction = ship[i].ai.direction
				end
				
				if ship[n].ai.target == 0 and enemy > 0 then
					ship[n].ai.target = enemy
				end
			end
		end
	end
	
	local ship_point = { x = ship[n].x, y = ship[n].y }
	--up, down, left, right
	local speed_x = math.abs( ship[n].nx ) / ( 600 * ship_data.speed[ship[n].type] ) * 336
	local speed_y = math.abs( ship[n].ny ) / ( 600 * ship_data.speed[ship[n].type] ) * 236
	
	local size_x = 64 + speed_x
	local size_y = 64 + speed_y
	local quad = { { x = ship[n].x - 32, y = ship[n].y - 32 - size_y, width = 64, height = size_y  }, { x = ship[n].x - 32, y = ship[n].y + 32, width = 64, height = size_y }, { x = ship[n].x - 32 - size_x, y = ship[n].y - 32, width = size_x, height = 64 }, { x = ship[n].x + 32, y = ship[n].y - 32, width = size_x, height = 64 } }
	
	local numbers = { 1, 2, 3, 4 }
	
	if ship[n].ai.direction == 0 then
		for i = 4, 1 do
			for j = 1, #wall do
				if quad[i].x + quad[i].width > wall[j].x and quad[i].x < wall[j].x + wall[j].width and quad[i].y + quad[i].height > wall[j].y and quad[i].y < wall[j].y + wall[j].height then
					table.remove( numbers, i )
					break
				end
			end
			if i == numbers[i] then
				if #ship[n].ai.zone > 1 then
					for j = 1, #ship[n].ai.zone - 1 do
						if quad[i].x + quad[i].width > ship[n].ai.zone[j].x and quad[i].x < ship[n].ai.zone[j].x + ship[n].ai.zone[j].width and quad[i].y + quad[i].height > ship[n].ai.zone[j].y and quad[i].y < ship[n].ai.zone[j].y + ship[n].ai.zone[j].height then
							table.remove( numbers, i )
							break
						end
					end
				end
			end
		end
		
		local number = numbers[math.random( #numbers )]
		if #numbers == 0 then
			number = math.random( 4 )
		end
		
		ship[n].ai.direction = numbers[number]
		--ship[n].ai.zone[#ship[n].ai.zone + 1] = { x = ship[n].x, y = ship[n].y, width = 0, height = 0 }
		if #ship[n].ai.zone > 10 then
			table.remove( ship[n].ai.zone, 1 )
		end
		keys[ship[n].ai.direction] = true
	else
		keys[ship[n].ai.direction] = true
		
		for i = 1, #wall do
			if quad[ship[n].ai.direction].x + quad[ship[n].ai.direction].width > wall[i].x and quad[ship[n].ai.direction].x < wall[i].x + wall[i].width and quad[ship[n].ai.direction].y + quad[ship[n].ai.direction].height > wall[i].y and quad[ship[n].ai.direction].y < wall[i].y + wall[i].height then
				ship[n].ai.direction = 0
				break
			end
		end
		
		if ship[n].ai.direction ~= 0 then
			local turn = { 1, 2 }
			if ship[n].ai.direction < 3 then
				turn = { 3, 4 }
			end
			
			local size_x = 400
			local size_y = 300
			local quad = { { x = ship[n].x - 32, y = ship[n].y - 32 - size_y, width = 64, height = size_y  }, { x = ship[n].x - 32, y = ship[n].y + 32, width = 64, height = size_y }, { x = ship[n].x - 32 - size_x, y = ship[n].y - 32, width = size_x, height = 64 }, { x = ship[n].x + 32, y = ship[n].y - 32, width = size_x, height = 64 } }
			
			
			for j = 2, 1 do
				for i = 1, #wall do
					if quad[ship[n].ai.direction].x + quad[ship[n].ai.direction].width > wall[i].x and quad[ship[n].ai.direction].x < wall[i].x + wall[i].width and quad[ship[n].ai.direction].y + quad[ship[n].ai.direction].height > wall[i].y and quad[ship[n].ai.direction].y < wall[i].y + wall[i].height then
						table.remove( turn, j )
						break
					end
				end
			end
			
			if #turn > 0 then
				keys[turn[math.random( #turn )]] = true
			end
		end
	end
	
	local collectibles = { }
	status = false
	if #collectible > 0 then
		for i = 1, #collectible do
			local x = collectible[i].x - ship[n].x
			local y = collectible[i].y - ship[n].y
			if x > -400 and x < 400 and y > -300 and y < 300 then
				collectibles[#collectibles + 1] = i
				if i == ship[n].ai.collectible then
					status = true
					break
				end
			end
		end
	else
		ship[n].ai.collectible = 0
	end
	
	if not status and #collectibles > 0 then
		for i = 1, #collectibles do
			if ship[n].shields <= 100 and collectible[i].type == 'shields' then
				ship[n].ai.collectible = i
				break
			elseif ship[n].energy < 150 and collectible[i].type == 'energy' then
				ship[n].ai.collectible = i
				break
			end
		end
	end
	
	if ship[n].ai.collectible > 0 then
		local x = collectible[ship[n].ai.collectible].x - ship[n].x
		local y = collectible[ship[n].ai.collectible].y - ship[n].y
		if x > -400 and x < 400 and y > -300 and y < 300 then
			if ship[n].y > collectible[ship[n].ai.collectible].y then
				keys[1] = true
				keys[2] = false
			elseif ship[n].y < collectible[ship[n].ai.collectible].y then
				keys[2] = true
				keys[1] = false
			end
			if ship[n].x > collectible[ship[n].ai.collectible].x then
				keys[3] = true
				keys[4] = false
			elseif ship[n].x < collectible[ship[n].ai.collectible].x then
				keys[4] = true
				keys[3] = false
			end
		end
	end
	
	if ship[n].ai.direction ~= old_direction and #ship[n].ai.zone > 0 then
		local buffer = 0
		
		local max_x = ship[n].x
		local min_x = ship[n].ai.zone[#ship[n].ai.zone].x
		if min_x > max_x then
			buffer = max_x
			max_x = min_x
			min_x = buffer
		end
		
		local max_y = ship[n].y
		local min_y = ship[n].ai.zone[#ship[n].ai.zone].y
		if min_y > max_y then
			buffer = max_y
			max_y = min_y
			min_y = buffer
		end
		
		ship[n].ai.zone[#ship[n].ai.zone].x = min_x - 30
		ship[n].ai.zone[#ship[n].ai.zone].y = min_y - 30
		ship[n].ai.zone[#ship[n].ai.zone].width = max_x - min_x + 60
		ship[n].ai.zone[#ship[n].ai.zone].height = max_y - min_y + 60
	end
	
	return keys
end

function ai_mouse( n )
	local mouse = { false, false, ship[n].mouse[3], ship[n].mouse[4] }
	
	if ship[ship[n].ai.target] then
		if ship[ship[n].ai.target].death then
			ship[n].ai.target = 0
		end
	end
	
	if ship[n].ai.target > 0 then
		local x = ship[ship[n].ai.target].x - ship[n].x
		local y = ship[ship[n].ai.target].y - ship[n].y
		if ( x > -400 and x < 400 and y > -300 and y < 300 and not ship[ship[n].ai.target].death ) then
			mouse[1] = true
			
			if math.random( 100 ) > 96 then
				mouse[2] = true
			end
		end
		
		local x = ship[ship[n].ai.target].x - ship[n].x + 400
		local y = ship[ship[n].ai.target].y - ship[n].y + 300
		local sx = ship[n].mouse[3]
		local sy = ship[n].mouse[4]
		
		if x > 0 and x < 800 and y > 0 and y < 600 then
			if sx < x then
				sx = sx + math.random( 12, 16 )
			elseif sx > x then
				sx = sx - math.random( 12, 16 )
			end
			
			if sy < y then
				sy = sy + math.random( 12, 16 )
			elseif sy > y then
				sy = sy - math.random( 12, 16 )
			end
		else
			ship[n].ai.target = 0
		end
		
		mouse[3] = sx
		mouse[4] = sy
	end
	
	return mouse
end