ship_data = { }

weapon_name = { { 'Laser', 'Vauss', 'Mass Driver', 'Plasma', 'EMD' }, { 'Concussion', 'Frag', 'Homing', 'Pound', 'Black Shark' } }

for i = 1, #menu.ship do
	ship_data[menu.ship[i]] = love.graphics.newImage( 'ship/' .. menu.ship[i] .. '.png' )
	ship_data[menu.ship[i] .. '_shadow'] = love.graphics.newImage( 'ship/' .. menu.ship[i] .. '_shadow.png' )
end

ship_data['laser_1'] = love.graphics.newImage( 'texture/weapon/laser/weapon_1.png' )
ship_data['light_1'] = love.graphics.newImage( 'texture/weapon/laser/light_1.png' )
ship_data['laser_2'] = love.graphics.newImage( 'texture/weapon/laser/weapon_2.png' )
ship_data['light_2'] = love.graphics.newImage( 'texture/weapon/laser/light_2.png' )

ship_data['concussion'] = love.graphics.newImage( 'texture/weapon/concussion/weapon.png' )
ship_data['light'] = love.graphics.newImage( 'texture/weapon/concussion/light.png' )

ship_data['explosion'] = love.graphics.newImage( 'texture/effects/explosion/explosion_medium.png' )

ship_data.shields = { 200, 150, 250, 100, 300 }
ship_data.speed = { 1, 1.5, 0.75, 1.65, 0.5 }
ship_data.frequency = { 1, 1.25, 0.75, 2, 0.6 }
ship_data.angle = { -0.7, -0.7, -0.85, 1, -0.65 }

function ship_create( x, y, type, ai, name, team )
	ship[#ship + 1] = { x = x, y = y, nx = 0, ny = 0, angle = 0, shields = 200, part = { { x = 0, y = 0, nx = 0, ny = 0, angle = 0 }, { x = 0, y = 0, nx = 0, ny = 0, angle = 0 }, { x = 0, y = 0, nx = 0, ny = 0, angle = 0 }, { x = 0, y = 0, nx = 0, ny = 0, angle = 0 } }, weapon = { primary = 1, secondary = 1, status = { { true, false, false, false, false }, { 7, 0, 0, 0, 0 } }, type = 1, side = { ship_data.angle[type], ship_data.angle[type] } }, energy = 100, bullet = { }, missle = { }, timer = { 0, 0 }, type = type, keys = { }, mouse = { false, false, 0, 0 }, explosion = { alpha = 255 }, death = false, width = 64, height = 64, ai = { status = ai, target = 0, collectible = 0, direction = 0, zone = { } }, stats = { frags = 0, deaths = 0, name = name }, team = team }
end

function ship_recreate( x, y, type, ai, n, name, team )
	ship[n] = { x = x, y = y, nx = 0, ny = 0, angle = 0, shields = 200, part = { { x = 0, y = 0, nx = 0, ny = 0, angle = 0 }, { x = 0, y = 0, nx = 0, ny = 0, angle = 0 }, { x = 0, y = 0, nx = 0, ny = 0, angle = 0 }, { x = 0, y = 0, nx = 0, ny = 0, angle = 0 } }, weapon = { primary = 1, secondary = 1, status = { { true, false, false, false, false }, { 7, 0, 0, 0, 0 } }, type = 1, side = { ship_data.angle[type], ship_data.angle[type] } }, energy = 100, bullet = ship[n].bullet, missle = ship[n].missle, timer = { 0, 0 }, type = type, keys = { }, mouse = { ship[n].mouse[1], ship[n].mouse[2], ship[n].mouse[3], ship[n].mouse[4] }, explosion = { alpha = 255 }, death = false, width = 64, height = 64, ai = { status = ai, target = 0, collectible = 0, direction = 0, zone = { } }, stats = { frags = ship[n].stats.frags, deaths = ship[n].stats.deaths, name = name }, team = team }
end

function ship_check( n )
	for i = 1, #ship do
		if not ship[i].death then
			if ship[n].x + ship[n].width > ship[i].x and ship[n].x < ship[i].x + ship[i].width and ship[n].y + ship[n].height > ship[i].y and ship[n].y < ship[i].y + ship[i].height and i ~= n then 
				if ship[n].x + ship[n].width > ship[i].x and ship[n].x + ship[n].width < ship[i].x + 24 then
					ship[n].x = ship[i].x - ship[n].width
					ship[n].nx = 0
				elseif ship[n].x < ship[i].x + ship[i].width and ship[n].x > ship[i].x + ship[i].width - 24 then
					ship[n].x = ship[i].x + ship[i].width
					ship[n].nx = 0
				end
				if ship[n].y + ship[n].height > ship[i].y and ship[n].y + ship[n].height < ship[i].y + 24 then
					ship[n].y = ship[i].y - ship[n].height
					ship[n].ny = 0
				elseif ship[n].y < ship[i].y + ship[i].height and ship[n].y > ship[i].y + ship[i].height - 24 then
					ship[n].y = ship[i].y + ship[i].height
					ship[n].ny = 0
				end
			end
		end
	end
end

love.filesystem.load( 'ship/ai.lua' ) ( )

function ship_keys( n )
	local keys = { 'w', 's', 'a', 'd' }
	
	if ship[n].ai.status then
		ship[n].keys = ai_keys( n )
	else
		if n == game.player then
			for i = 1, #keys do
				ship[n].keys[i] = love.keyboard.isDown( keys[i] )
				if ship[n].keys[i] then
					ship[n].ai.direction = i
				end
			end
		end
	end
end

function ship_mouse( n )
	local mouse = { 'l', 'r' }
	
	if ship[n].ai.status then
		ship[n].mouse = ai_mouse( n )
	else
		if n == game.player then
			for i = 1, #mouse do
				ship[n].mouse[i] = love.mouse.isDown( mouse[i] )
			end
			ship[n].mouse[3] = love.mouse.getX( )
			ship[n].mouse[4] = love.mouse.getY( )
		end
	end
end

function ship_update( n, dt )
	if #ship[n].bullet then
		local i = 1
		local k = #ship[n].bullet
		while true do
			if i <= k and i > 0 then
				if ship[n].bullet[i].alpha == 255 then
					ship[n].bullet[i].x = ship[n].bullet[i].x + ship[n].bullet[i].nx * dt
					ship[n].bullet[i].y = ship[n].bullet[i].y + ship[n].bullet[i].ny * dt
					local x, y = ship[n].bullet[i].x, ship[n].bullet[i].y
					local status = false
					for j = 1, #wall do
						if x > wall[j].x and x < wall[j].x + wall[j].width and y > wall[j].y and y < wall[j].y + wall[j].height then
							ship[n].bullet[i].alpha = 254
							status = true
							
							local ox, oy = x, y
							local x = ship[game.camera].x - x
							local y = ship[game.camera].y - y
							local distance = math.sqrt( x * x + y * y )
							if distance < 2048 then
								sound[#sound + 1] = love.audio.newSource( 'sound/weapon/laser/wall.ogg', 'static' )
								sound[#sound]:setVolume( ( 2048 - distance ) / 4096 )
								love.audio.play( sound[#sound] )
							end
						end
					end
					if not status then
						for j = 1, #ship do
							if x > ship[j].x and x < ship[j].x + ship[j].width and y > ship[j].y and y < ship[j].y + ship[j].height and n ~= j and not ship[j].death then
								ship[j].shields = ship[j].shields - 10
								ship[n].bullet[i].alpha = 254
								
								for m = 1, 5 do
									ship[n].bullet[i].spark[m] = { x = ship[n].bullet[i].x, y = ship[n].bullet[i].y, nx = math.random( -40, 40 ), ny = math.random( -40, 40 ) }
								end
								
								if ship[j].shields < 0 then
									ship[n].stats.frags = ship[n].stats.frags + 1
									
									local score = 1
									if ship[j].team == ship[n].team then
										score = -1
									end
									
									game.score[ship[n].team] = game.score[ship[n].team] + score
									message[#message + 1] = ship[n].stats.name .. ' killed ' .. ship[j].stats.name
								end
								
								if j == game.player then
									sound[#sound + 1] = love.audio.newSource( 'sound/hit.ogg', 'static' )
									love.audio.play( sound[#sound] )
								else
									local ox, oy = x, y
									local x = ship[game.camera].x - x
									local y = ship[game.camera].y - x
									local distance = math.sqrt( x * x + y * y )
									if distance < 2048 then
										sound[#sound + 1] = love.audio.newSource( 'sound/weapon/hit.ogg', 'static' )
										sound[#sound]:setVolume( ( 2048 - distance ) / 4096 )
										love.audio.play( sound[#sound] )
									end
								end
							end
						end
					end
				else
					if ship[n].bullet[i].alpha > 0 then
						ship[n].bullet[i].alpha = ship[n].bullet[i].alpha - 1024 * dt
						
						if #ship[n].bullet[i].spark > 0 then
							for j = 1, 5 do
								ship[n].bullet[i].spark[j].x = ship[n].bullet[i].spark[j].x + ship[n].bullet[i].spark[j].nx * dt * 10
								ship[n].bullet[i].spark[j].y = ship[n].bullet[i].spark[j].y + ship[n].bullet[i].spark[j].ny * dt * 10
							end
						end
						
						if ship[n].bullet[i].alpha < 0 then
							table.remove( ship[n].bullet, i )
							k = k - 1
							i = i - 1
						end
					end
				end
				i = i + 1
			else
				break
			end
		end
	end
	
	if #ship[n].missle then
		local i = 1
		local k = #ship[n].missle
		while true do
			if i <= k and i > 0 then
				if ship[n].missle[i].alpha == 255 then
					ship[n].missle[i].x = ship[n].missle[i].x + ship[n].missle[i].nx * dt
					ship[n].missle[i].y = ship[n].missle[i].y + ship[n].missle[i].ny * dt
					local x, y = ship[n].missle[i].x, ship[n].missle[i].y
					local status = false
					for j = 1, #wall do
						if x > wall[j].x and x < wall[j].x + wall[j].width and y > wall[j].y and y < wall[j].y + wall[j].height then
							ship[n].missle[i].alpha = 254
							status = true
							
							local ox, oy = x, y
							local x = ship[game.camera].x - x
							local y = ship[game.camera].y - y
							local distance = math.sqrt( x * x + y * y )
							if distance < 2048 then
								sound[#sound + 1] = love.audio.newSource( 'sound/explosion.ogg', 'static' )
								sound[#sound]:setVolume( ( 2048 - distance ) / 4096 )
								love.audio.play( sound[#sound] )
							end
						end
					end
					if not status then
						for j = 1, #ship do
							if x > ship[j].x and x < ship[j].x + ship[j].width and y > ship[j].y and y < ship[j].y + ship[j].height and n ~= j and not ship[j].death then
								ship[j].shields = ship[j].shields - 10
								ship[n].missle[i].alpha = 254
								
								for m = 1, 5 do
									ship[n].missle[i].spark[m] = { x = ship[n].missle[i].x, y = ship[n].missle[i].y, nx = math.random( -40, 40 ), ny = math.random( -40, 40 ) }
								end
								
								if ship[j].shields < 0 then
									ship[n].stats.frags = ship[n].stats.frags + 1
									
									local score = 1
									if ship[j].team == ship[n].team then
										score = -1
									end
									
									game.score[ship[n].team] = game.score[ship[n].team] + score
									message[#message + 1] = ship[n].stats.name .. ' killed ' .. ship[j].stats.name
								end
								
								if j == game.player then
									sound[#sound + 1] = love.audio.newSource( 'sound/hit.ogg', 'static' )
									love.audio.play( sound[#sound] )
								else
									local ox, oy = x, y
									local x = ship[game.camera].x - x
									local y = ship[game.camera].y - x
									local distance = math.sqrt( x * x + y * y )
									if distance < 2048 then
										sound[#sound + 1] = love.audio.newSource( 'sound/explosion.ogg', 'static' )
										sound[#sound]:setVolume( ( 2048 - distance ) / 4096 )
										love.audio.play( sound[#sound] )
									end
								end
							end
						end
					end
					
					if ship[n].missle[i].alpha == 254 then
						for j = 1, #ship do
							local distance = math.sqrt( ( ship[n].missle[i].x - ship[j].x ) ^ 2 + ( ship[n].missle[i].y - ship[j].y ) ^ 2 )
							if distance < 192 then
								ship[j].shields = ship[j].shields - ( distance / 192 ) * 40
								ship[j].nx = ship[j].nx - ( ( ship[n].missle[i].x - ship[j].x ) / distance ) * 275 * ship_data.speed[ship[n].type]
								ship[j].ny = ship[j].ny - ( ( ship[n].missle[i].y - ship[j].y ) / distance ) * 275 * ship_data.speed[ship[n].type]
								
								if ship[j].shields < 0 then
									message[#message + 1] = ship[n].stats.name .. ' killed ' .. ship[j].stats.name
								end
							end
						end
					end
				else
					if ship[n].missle[i].alpha > 0 then
						ship[n].missle[i].alpha = ship[n].missle[i].alpha - 1024 * dt
						
						if ship[n].missle[i].alpha < 0 then
							table.remove( ship[n].missle, i )
							k = k - 1
							i = i - 1
						end
					end
				end
				i = i + 1
			else
				break
			end
		end
	end
	
	if not ship[n].death then
		ship_keys( n )
		ship_mouse( n )
		
		ship[n].x = ship[n].x + ship[n].nx * dt
		ship[n].y = ship[n].y + ship[n].ny * dt
		
		wall_check( n )
		ship_check( n )
		
		ship[n].angle = math.atan2( ship[n].mouse[4] - 300, ship[n].mouse[3] - 400 ) / math.pi + 0.5
		
		ship[n].timer[1] = ship[n].timer[1] + 1 * dt
		if ship[n].mouse[1] and ship[n].timer[1] > 0.075 * ship_data.frequency[ship[n].type] and ship[n].energy > 0 then
			ship[n].bullet[#ship[n].bullet + 1] = { x = ship[n].x + 32 + 32 * math.cos( ( ship[n].angle + ship[n].weapon.side[1] + 0.5 ) * math.pi ), y = ship[n].y + 32 + 32 * math.sin( ( ship[n].angle + ship[n].weapon.side[1] + 0.5 ) * math.pi ), nx = 1500 * math.cos( ( ship[n].angle - 0.5 ) * math.pi ), ny = 1500 * math.sin( ( ship[n].angle - 0.5 ) * math.pi ), angle = ship[n].angle, type = ship[n].weapon.type, alpha = 255, spark = { } }
			ship[n].weapon.side[1] = ship[n].weapon.side[1] * -1
			ship[n].timer[1] = 0
			ship[n].energy = ship[n].energy - 0.25
			
			local x = ship[game.camera].x - ship[n].x
			local y = ship[game.camera].y - ship[n].y
			local distance = math.sqrt( x * x + y * y )
			if distance < 2048 then
				sound[#sound + 1] = love.audio.newSource( 'sound/weapon/laser/fire.ogg', 'static' )
				sound[#sound]:setVolume( ( 2048 - distance ) / 4096 )
				love.audio.play( sound[#sound] )
			end
		end
		
		ship[n].timer[2] = ship[n].timer[2] + 1 * dt
		if ship[n].mouse[2] and ship[n].timer[2] > 0.5 * ship_data.frequency[ship[n].type] and ship[n].weapon.status[2][1] > 0 then
			ship[n].missle[#ship[n].missle + 1] = { x = ship[n].x + 32 + 32 * math.cos( ( ship[n].angle + ship[n].weapon.side[2] + 0.5 ) * math.pi ), y = ship[n].y + 32 + 32 * math.sin( ( ship[n].angle + ship[n].weapon.side[2] + 0.5 ) * math.pi ), nx = 1000 * math.cos( ( ship[n].angle - 0.5 ) * math.pi ), ny = 1000 * math.sin( ( ship[n].angle - 0.5 ) * math.pi ), angle = ship[n].angle, type = ship[n].weapon.type, alpha = 255, spark = { } }
			ship[n].weapon.side[2] = ship[n].weapon.side[2] * -1
			ship[n].timer[2] = 0
			ship[n].weapon.status[2][1] = ship[n].weapon.status[2][1] - 1
			
			local x = ship[game.camera].x - ship[n].x
			local y = ship[game.camera].y - ship[n].y
			local distance = math.sqrt( x * x + y * y )
			if distance < 2048 then
				sound[#sound + 1] = love.audio.newSource( 'sound/weapon/concussion/fire.ogg', 'static' )
				sound[#sound]:setVolume( ( 2048 - distance ) / 2048 )
				love.audio.play( sound[#sound] )
			end
		end
		
		if ship[n].shields < 0 then
			ship[n].death = true
			
			local x = ship[game.camera].x - ship[n].x
			local y = ship[game.camera].y - ship[n].y
			local distance = math.sqrt( x * x + y * y )
			if distance < 2048 then
				sound[#sound + 1] = love.audio.newSource( 'sound/explosion.ogg', 'static' )
				sound[#sound]:setVolume( ( 2048 - distance ) / 2048 )
				love.audio.play( sound[#sound] )
			end
			
			if math.random( 0, 1 ) == 1 then
				collectible_create( ship[n].x + math.random( 1, 64 ), ship[n].y + math.random( 1, 64 ), 'energy' )
			end
			if math.random( 0, 1 ) == 1 then
				collectible_create( ship[n].x + math.random( 1, 64 ), ship[n].y + math.random( 1, 64 ), 'shields' )
			end
			
			for i = 1, 4 do
				ship[n].part[i].x = ship[n].x
				ship[n].part[i].y = ship[n].y
				
				ship[n].part[i].nx = 1000 - math.random( 2000 )
				ship[n].part[i].ny = 1000 - math.random( 2000 )
				
				ship[n].part[i].angle = math.random( 0, 0.3 )
			end
		end
		
		local speed = 600 * ship_data.speed[ship[n].type]
		
		if ship[n].keys[1] then
			ship[n].ny = ship[n].ny - speed * dt
			if ship[n].ny < -1 * speed then
				ship[n].ny = -1 * speed
			end
		end
		if ship[n].keys[2] then
			ship[n].ny = ship[n].ny + speed * dt
			if ship[n].ny > speed then
				ship[n].ny = speed
			end
		end
		if ship[n].keys[3] then
			ship[n].nx = ship[n].nx - speed * dt
			if ship[n].nx < -1 * speed then
				ship[n].nx = -1 * speed
			end
		end
		if ship[n].keys[4] then
			ship[n].nx = ship[n].nx + speed * dt
			if ship[n].nx > speed then
				ship[n].nx = speed
			end
		end
		
		local brake = 400 * ship_data.speed[ship[n].type]
		
		if ship[n].nx > 0 then
			ship[n].nx = ship[n].nx - brake * dt
		elseif ship[n].nx < 0 then
			ship[n].nx = ship[n].nx + brake * dt
		end
		if ship[n].ny > 0 then
			ship[n].ny = ship[n].ny - brake * dt
		elseif ship[n].ny < 0 then
			ship[n].ny = ship[n].ny + brake * dt
		end
	else
		if ship[n].explosion.alpha > 0 then
			ship[n].explosion.alpha = ship[n].explosion.alpha - 255 * dt
			if ship[n].explosion.alpha < 0 then
				ship[n].explosion.alpha = 0
				ship[n].stats.deaths = ship[n].stats.deaths + 1
				
				local allowed = { }
				local ships = { }
				for i = 1, #spawn_point[ship[n].team] do
					for j = 1, #ship do
						if j ~= n then
							if spawn_point[ship[n].team][i].x + ship[n].width > ship[j].x and spawn_point[ship[n].team][i].x < ship[j].x + ship[j].width and spawn_point[ship[n].team][i].y + ship[n].height > ship[j].y and spawn_point[ship[n].team][i].y < ship[j].y + ship[j].height then
								ships[#ships + 1] = { ship = j, point = i }
							else
								allowed[#allowed + 1] = i
							end
						end
					end
				end
				
				local point
				
				if #allowed > 0 then
					point = allowed[math.random( 1, #allowed )]
				else
					local k = math.random( 1, #ships )
					point = ships[k].point
					ship[ships[k].ship].shields = -1
				end
				
				ship_recreate( spawn_point[ship[n].team][point].x, spawn_point[ship[n].team][point].y, ship[n].type, ship[n].ai.status, n, ship[n].stats.name, ship[n].team )
			end
			
			for i = 1, 4 do
				ship[n].part[i].x = ship[n].part[i].x + ship[n].part[i].nx * dt
				ship[n].part[i].y = ship[n].part[i].y + ship[n].part[i].ny * dt
			end
		end
	end
end

function ship_draw( n )
	if not ship[n].death then
		love.graphics.setColor( 0, 0, 0, 64 )
		love.graphics.draw( ship_data[menu.ship[ship[n].type] .. '_shadow'], ship[n].x + ship[n].width / 2 - game.x - 24, ship[n].y + ship[n].height / 2 - game.y + 24, ship[n].angle * math.pi, 1, 1, 32, 32 )
	end
	
	love.graphics.setColor( 255, 255, 255, 128 )
	if #ship[n].bullet > 0 then
		for i = 1, #ship[n].bullet do
			love.graphics.setColor( 255, 255, 255, ship[n].bullet[i].alpha )
			love.graphics.draw( ship_data['light_' .. ship[n].team], ship[n].bullet[i].x - game.x - 64, ship[n].bullet[i].y - game.y - 64 )
			
			if ship[n].bullet[i].alpha == 255 then
				love.graphics.setColor( 255, 255, 255, 255 )
				love.graphics.draw( ship_data['laser_' .. ship[n].team], ship[n].bullet[i].x - game.x, ship[n].bullet[i].y - game.y, ship[n].bullet[i].angle * math.pi, 1, 1, 32, 32 )
			end
			
			if #ship[n].bullet[i].spark > 0 then
				love.graphics.setColor( level.team.colour[ship[n].team].red, level.team.colour[ship[n].team].green, level.team.colour[ship[n].team].blue, ship[n].bullet[i].alpha / 2 )
				for j = 1, 5 do
					love.graphics.line( ship[n].bullet[i].spark[j].x - game.x, ship[n].bullet[i].spark[j].y - game.y, ship[n].bullet[i].spark[j].x + ship[n].bullet[i].spark[j].nx / 4 - game.x, ship[n].bullet[i].spark[j].y + ship[n].bullet[i].spark[j].ny / 4 - game.y )
				end
			end
		end
	end
	
	if #ship[n].missle > 0 then
		for i = 1, #ship[n].missle do
			love.graphics.setColor( 255, 255, 255, ship[n].missle[i].alpha / 4 )
			love.graphics.draw( ship_data['light'], ship[n].missle[i].x - game.x - 64, ship[n].missle[i].y - game.y - 64 )
			
			if ship[n].missle[i].alpha == 255 then
				love.graphics.setColor( 255, 255, 255, 255 )
				love.graphics.draw( ship_data['concussion'], ship[n].missle[i].x - game.x, ship[n].missle[i].y - game.y, ship[n].missle[i].angle * math.pi, 1, 1, 32, 32 )
			else
				love.graphics.setColor( 255, 255, 255, ship[n].missle[i].alpha )
				love.graphics.draw( ship_data['explosion'], ship[n].missle[i].x - game.x - 64, ship[n].missle[i].y - game.y - 64 )
			end
		end
	end
	
	if not ship[n].death then
		love.graphics.setColor( 194 + level.team.colour[ship[n].team].red / 5, 194 + level.team.colour[ship[n].team].green / 5, 194 +  level.team.colour[ship[n].team].blue / 5, 255 )
		love.graphics.draw( ship_data[menu.ship[ship[n].type]], ship[n].x + ship[n].width / 2 - game.x, ship[n].y + ship[n].height / 2 - game.y, ship[n].angle * math.pi, 1, 1, 32, 32 )
		
		if ship[n].team == ship[game.camera].team then
			love.graphics.setColor( 0, 0, 0, 255 )
			love.graphics.print( ship[n].stats.name, ship[n].x - game.x, ship[n].y - game.y )
			love.graphics.setColor( level.team.colour[ship[n].team].red, level.team.colour[ship[n].team].green, level.team.colour[ship[n].team].blue )
			love.graphics.print( ship[n].stats.name, ship[n].x - game.x - 1, ship[n].y - game.y - 1 )
		end
	else
		love.graphics.setColor( 194 + level.team.colour[ship[n].team].red / 5, 194 + level.team.colour[ship[n].team].green / 5, 194 +  level.team.colour[ship[n].team].blue / 5, ship[n].explosion.alpha )
		
		local quads = { { x = 0, y = 0 }, { x = 32, y = 0 }, { x = 32, y = 32 }, { x = 0, y = 32 } }
		for i = 1, 4 do
			local quad = love.graphics.newQuad( quads[i].x, quads[i].y, 32, 32, 64, 64 )
			love.graphics.drawq( ship_data[menu.ship[ship[n].type]], quad, ship[n].part[i].x + ship[n].width / 2 - game.x, ship[n].part[i].y + ship[n].height / 2 - game.y, ship[n].angle, 1, 1, 16, 16 )
		end
		
		love.graphics.setColor( 255, 255, 255, ship[n].explosion.alpha )
		love.graphics.draw( ship_data['explosion'], ship[n].x + ship[n].width / 2 - game.x - 64, ship[n].y + ship[n].height / 2 - game.y - 64 )
	end
end